<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { ref, computed, onMounted } from "vue";
    import useNavigationStore from "./../stores/navigation";
    import { useMutation } from "@vue/apollo-composable";
    import { SexEnum } from "./../gql/graphql";
    import { useRouter } from "vue-router";
    import VDatePicker from "./Wrappers/DatePicker.vue";
    import { SexEnumTranslation } from "../gql/enum-translations";
    import HashReattachmentSystem from "./RegisterCards/HashReattachmentSystem.vue";
    import useImportStore from "./../stores/import";
    import UnregisterImportButton from "./UnregisterImportButton.vue";
    import { DynamicRoutePaths } from "../plugins/router";

    const navigationStore = useNavigationStore();
    const importStore = useImportStore();
    const router = useRouter();
    const valid = ref(false);
    const freshParticipant = ref({
        sex: SexEnum.Male,
        street: "",
        streetNumber: "",
        postalCode: "",
        givenName: "",
        gender: "",
        familyName: "",
        country: "Deutschland",
        city: "",
        callName: "",
        birthDate: "2010-01-01",
    });
    const form = ref(null);

    onMounted(() => {
        if (importStore.importedStructure != null) {
            [
                "birthDate",
                "callName",
                "familyName",
                "sex",
                "givenName",
                "gender",
                "street",
                "streetNumber",
                "postalCode",
                "city",
            ].forEach((key) => {
                // unsafe...  Do not care.
                (freshParticipant.value as any)[key] = importStore.getParsedValueOrDefault(key);
            });
        }

        (form.value as any).validate();
    });

    // mutation
    const creatingMutation = graphql(`
        mutation CreateParticipant(
            $sex: SexEnum = MALE
            $street: String = ""
            $streetNumber: String = ""
            $postalCode: String = ""
            $givenName: String = ""
            $gender: String = ""
            $familyName: String = ""
            $country: String = ""
            $city: String = ""
            $callName: String = ""
            $birthDate: Date = "0001-01-01"
        ) {
            createParticipant(
                values: {
                    givenName: $givenName
                    familyName: $familyName
                    callName: $callName
                    sex: $sex
                    gender: $gender
                    birthDate: $birthDate
                    street: $street
                    streetNumber: $streetNumber
                    postalCode: $postalCode
                    city: $city
                    country: $country
                }
            ) {
                id
            }
        }
    `);
    const { mutate: executeCreateParticipant, onDone: participantCreated } = useMutation(creatingMutation, () => ({
        variables: freshParticipant.value,
        fetchPolicy: "network-only",
    }));

    participantCreated((result) => {
        let id = result.data?.createParticipant?.id ?? "";

        if (id != "") {
            navigationStore.participantId = id;
            router.push({ name: DynamicRoutePaths.ParticipantDetails }); // TODO move this out possibly
        }
    });

    const sexSelect = computed(() => {
        let res = [] as { value: SexEnum; title: string }[];

        // do not include redacted, therefore no "Object.values"
        [SexEnum.Male, SexEnum.Female, SexEnum.Diverse, SexEnum.Redacted].forEach((sex) => {
            res.push({
                value: sex,
                title: SexEnumTranslation(sex),
            });
        });

        return res;
    });

    function validate() {
        (form.value as any).validate();
    }
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Teilnehmer erstellen</h2>

        <HashReattachmentSystem
            :birth-date="freshParticipant.birthDate"
            :call-name="freshParticipant.callName != '' ? freshParticipant.callName : freshParticipant.givenName.split(' ')[0]"
            :family-name="freshParticipant.familyName"
            :given-name="freshParticipant.givenName"
        ></HashReattachmentSystem>

        <div style="display: flex; width: 100%">
            <UnregisterImportButton style="margin-left: auto" />
        </div>

        <v-card title="Neuer Teilnehmer" variant="tonal" class="my-2">
            <template v-slot:text>
                <v-form
                    ref="form"
                    v-model="valid"
                    @submit.prevent="
                        () => {
                            if (valid) {
                                executeCreateParticipant();
                            }
                        }
                    "
                >
                    <v-row class="mb-6 justify-center" no-gutters dense>
                        <v-text-field
                            density="comfortable"
                            v-model="freshParticipant.givenName"
                            label="Vorname"
                            class="v-col-md-7"
                            :rules="[
                                (value: any) => {
                                    if (value?.length > 0) return true;
                                    return 'Vorname muss gesetzt sein';
                                },
                            ]"
                        ></v-text-field>
                        <v-text-field
                            density="comfortable"
                            v-model="freshParticipant.familyName"
                            label="Familienname"
                            class="v-col-md-7"
                            :rules="[
                                (value: any) => {
                                    if (value?.length > 0) return true;
                                    return 'Familienname muss gesetzt sein';
                                },
                            ]"
                        ></v-text-field>
                        <v-text-field
                            density="comfortable"
                            v-model="freshParticipant.callName"
                            label="Rufname (muss nicht gesetzt werden)"
                            class="v-col-md-7"
                        ></v-text-field>
                        <v-select
                            density="comfortable"
                            class="v-col-md-7"
                            v-model="freshParticipant.sex"
                            label="Sex (Rechtliches Geschlecht)"
                            :items="sexSelect"
                        ></v-select>
                        <v-text-field
                            density="comfortable"
                            v-model="freshParticipant.gender"
                            label="Gender (präferiertes Geschlecht, muss nicht gesetzt werden)"
                            class="v-col-md-7"
                        ></v-text-field>
                        <v-date-picker
                            v-model="freshParticipant.birthDate"
                            density="comfortable"
                            label="Geburtstag"
                            class="v-col-md-7"
                        ></v-date-picker>
                        <v-text-field
                            v-model="freshParticipant.street"
                            density="comfortable"
                            label="Straßenname"
                            class="v-col-md-7"
                        ></v-text-field>
                        <v-text-field
                            v-model="freshParticipant.streetNumber"
                            density="comfortable"
                            label="Hausnummer"
                            class="v-col-md-7"
                        ></v-text-field>
                        <v-text-field
                            v-model="freshParticipant.postalCode"
                            density="comfortable"
                            label="Postleitzahl"
                            class="v-col-md-7"
                            :rules="[
                                (value: any) => {
                                    const pattern = /^(?:\d{5})?$/;
                                    return (
                                        pattern.test(value) ||
                                        'Postleitzahl muss aus 5 Zahlen bestehen. (Sollte diese Regel nicht erfüllbar sein, 00000 eingeben und im nächsten Screen ändern)'
                                    );
                                },
                            ]"
                        ></v-text-field>
                        <v-text-field
                            v-model="freshParticipant.city"
                            density="comfortable"
                            label="Stadt"
                            class="v-col-md-7"
                        ></v-text-field>
                        <v-spacer class="v-col-12 mb-5"></v-spacer>
                        <v-btn class="v-col-6" type="submit" :disabled="!valid" @click="validate">
                            <template v-slot:prepend> <span class="material-symbols-outlined"> person_add </span></template>
                            Create
                        </v-btn>
                    </v-row>
                </v-form>
            </template>
        </v-card>
    </div>
</template>
